﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace IssueReproduction
{
  /// <summary>
  /// Suivez les étapes 1a ou 1b puis 2 pour utiliser ce contrôle personnalisé dans un fichier XAML.
  ///
  /// Étape 1a) Utilisation de ce contrôle personnalisé dans un fichier XAML qui existe dans le projet actif.
  /// Ajoutez cet attribut XmlNamespace à l'élément racine du fichier de balisage où il doit 
  /// être utilisé :
  ///
  ///     xmlns:MyNamespace="clr-namespace:IssueReproduction"
  ///
  ///
  /// Étape 1b) Utilisation de ce contrôle personnalisé dans un fichier XAML qui existe dans un autre projet.
  /// Ajoutez cet attribut XmlNamespace à l'élément racine du fichier de balisage où il doit 
  /// être utilisé :
  ///
  ///     xmlns:MyNamespace="clr-namespace:IssueReproduction;assembly=IssueReproduction"
  ///
  /// Vous devrez également ajouter une référence du projet contenant le fichier XAML
  /// à ce projet et régénérer pour éviter des erreurs de compilation :
  ///
  ///     Cliquez avec le bouton droit sur le projet cible dans l'Explorateur de solutions, puis sur
  ///     "Ajouter une référence"->"Projets"->[Recherchez et sélectionnez ce projet]
  ///
  ///
  /// Étape 2)
  /// Utilisez à présent votre contrôle dans le fichier XAML.
  ///
  ///     <MyNamespace:UserControlWithAButton/>
  ///
  /// </summary>
  public class UserControlWithAButton : UserControl
  {
    static UserControlWithAButton()
    {
      DefaultStyleKeyProperty.OverrideMetadata(typeof(UserControlWithAButton), new FrameworkPropertyMetadata(typeof(UserControlWithAButton)));
    }
    public UserControlWithAButton()
      : base()
    {
      this.DataContextChanged += (s, e) =>
      {
        if (e.NewValue != null && e.NewValue is IControlWithAButton)
        {
          IControlWithAButton control = (IControlWithAButton)DataContext;
          this.AButton = control.TheButton;
        }
        else
          this.AButton = null;
      };
    }

    /*
	protected override void OnContentChanged(object oldContent, object newContent)
	{
		// don't call the base so the content is not made a logical child
		//base.OnContentChanged(oldContent, newContent);
	}

	protected override System.Collections.IEnumerator LogicalChildren
	{
		get
		{
			// do not call the base since that will return the content
			// as a logical child which it is not. instead return an empty 
			// enumerator
			//return base.LogicalChildren;
			return new object[0].GetEnumerator();
		}
	}
    */


    public Button AButton
    {
      get { return (Button)GetValue(AButtonProperty); }
      set { SetValue(AButtonProperty, value); }
    }

    // Using a DependencyProperty as the backing store for AButton.  This enables animation, styling, binding, etc...
    public static readonly DependencyProperty AButtonProperty =
        DependencyProperty.Register("AButton", typeof(Button), typeof(UserControlWithAButton), new UIPropertyMetadata(null));

  }
}
